#ifndef TASK_H_
#define TASK_H_

typedef enum {
	TASK_MODE_UNKNOWN = -1, 
	TASK_MODE_CYCLE,
	TASK_MODE_BACKGROUND,
	TASK_MODE_INTERRUPT
} task_mode_t;

struct task {
	struct task	*next_task;
	char		name[NAME_MAX];
	task_mode_t	mode;
	unsigned int	intrn;

	unsigned char	*mmap_begin;
	size_t		mmap_size;

	uint32_t	pc;
	uint32_t	sp;
	uint32_t	fp;
	uint32_t	start_addr;
	uint32_t	stop_addr;

	uint32_t	*stack;
	unsigned int	stack_size;

	unsigned char	*text;
	unsigned int	text_size;

	unsigned char	*init;
	unsigned int	init_size;

	uint32_t 	*data;
	unsigned int	data_size;

	unsigned char	*ro;
	unsigned int	ro_size;

	unsigned char	*string;

	struct sym_tb_entry *sym_tb;
	unsigned int	sym_tb_size;
};

struct task *task_new(task_mode_t mode, const char *name);
void	task_free(struct task **task);

void	task_get_ctx(struct vm *machine, struct task *task);
void	task_set_ctx(struct vm *machine, struct task *task);
void	task_switch_ctx(struct vm *machine, struct task *old_task, struct task *new_task);

#endif /* TASK_H_ */
